from datetime import datetime
from sys import stderr

__all__ = [
    'log_warn',
    'log_debug', 'log_dbg',
    'log_info',
    'log_error',
    'log_fatal'
]


def log_func(*kwargs, log_mode, **args):
    print('[', time(), log_mode, ']', *kwargs, **args, file=stderr)


def log_warn(*kwargs, **args):
    log_func(*kwargs, log_mode='WARN', **args)


def log_debug(*kwargs, **args):
    log_func(*kwargs, log_mode='DBG ', **args)


def log_dbg(*kwargs, **args):
    log_debug(*kwargs, **args)


def log_info(*kwargs, **args):
    log_func(*kwargs, log_mode='INFO', **args)


def log_error(*kwargs, **args):
    log_func(*kwargs, log_mode='ERRO', **args)


def log_fatal(*kwargs, **args):
    log_func(*kwargs, log_mode='FATA', **args)
    exit(1)


def time():
    return datetime.utcnow().isoformat(sep=' ', timespec='milliseconds')
